package com.futu.course.common.handle;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import org.apache.ibatis.type.BaseTypeHandler;
import org.apache.ibatis.type.JdbcType;

import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

/**
 * @className: LongArrayTypeHandler
 * @Description:
 * @author: zhangxiong
 * @date: 2022/4/26/0026 19:24
 */
public class StringListTypeHandler extends BaseTypeHandler<List<String>> {
    @Override
    public void setNonNullParameter(PreparedStatement ps, int i, List<String> strings, JdbcType jdbcType) throws SQLException {
        String s = JSONUtil.toJsonStr(strings);
        ps.setString(i, s);
    }

    @Override
    public List<String> getNullableResult(ResultSet rs, String s) throws SQLException {
        if (rs.wasNull()){
            return null;
        }
        String str = rs.getString(s);
        JSONArray objects = JSONUtil.parseArray(str);
        return JSONUtil.toList(objects,String.class);

    }

    @Override
    public List<String> getNullableResult(ResultSet rs, int i) throws SQLException {
        if (rs.wasNull()){
            return null;
        }
        String str = rs.getString(i);
        JSONArray objects = JSONUtil.parseArray(str);
        return JSONUtil.toList(objects,String.class);
    }

    @Override
    public List<String> getNullableResult(CallableStatement cs, int i) throws SQLException {
        if (cs.wasNull()){
            return null;
        }
        String str = cs.getString(i);
        JSONArray objects = JSONUtil.parseArray(str);
        return JSONUtil.toList(objects,String.class);

    }
}
